#include "deu.h"

extern "C" {
	void add_thing(char *line);
	void add_thing_class(char *line);
}

static int end_of_decorate;

static int cur_dec_list = 0;
static int cur_dec_count = 0;

const char *next_string(char *s)
{
	static char *str;
	const char *tokens;
	char *dec_string = "";

	if(s)
	{
		str = s;
		while(*str && isspace(*str))
			++str;
		end_of_decorate = FALSE;
	}

	while(str)
	{
		if(!(*str))
		{
			end_of_decorate = TRUE;
			str = NULL;
			break;
		}

		if(strncmp(str, "//", 2) == 0)
		{
			while(*str != '\n' && *str != '\r')
				++str;
			while(*str == '\n' || *str == '\r')
				++str;

			continue;
		}

		if(*str == '"')
		{
			++str;
			tokens = "\"\r\n\t";
		}
		else
			tokens = " \r\n\t";

		dec_string = str;

		while(*str)
		{
			int i;
			for(i = 0;tokens[i];++i)
			{
				if(*str == tokens[i])
					break;
			}

			if(!tokens[i])
			{
				++str;
				continue;
			}

			for(;tokens[i];++i)
			{
				if(*str == tokens[i])
				{
					*(str++) = 0;
					i = -1;
					continue;
				}
			}

			return dec_string;
		}
	}

	return dec_string;
}

static int find_sprite(char *name)
{
	MDirPtr dir;

	strcat(name, "A0");
	dir = FindMasterDir(MasterDir, name);
	if(dir)
		return TRUE;

	name[strlen(name)-1] = '1';
	dir = FindMasterDir(MasterDir, name);
	if(dir)
		return TRUE;

	return FALSE;
}

void add_decorate(void)
{
	int edit_num, thing_rad;
	char thingname[64], spritename[16];

	const char *currtext;
	char *text = NULL;
	unsigned int running_size = 0;
	MDirPtr dir, next;

	dir = MasterDir;
	while(dir != NULL && (next = FindMasterDir(dir, "DECORATE")) != NULL)
	{
		dir = next;

		text = (char*)realloc(text, running_size + dir->dir.size + 1);

		if(running_size)
		{
			text[running_size] = '\n';
			++running_size;
		}

		BasicWadSeek(dir->wadfile, dir->dir.start);
		BasicWadRead(dir->wadfile, text + running_size, dir->dir.size);
		running_size += dir->dir.size;

		text[running_size] = 0;

		dir = dir->next;
	}

	if(!text)
		return;

	if(cur_dec_list)
		sprintf(thingname, "\"Decorate Things (%i)\"", cur_dec_list);
	else
		strcpy(thingname, "\"Decorate Things\"");
	add_thing_class(thingname);

	memset(thingname, 0, sizeof(thingname));
	end_of_decorate = FALSE;

	currtext = next_string(text);
	while(!end_of_decorate)
	{
		if(!thingname[0])
		{
			strcpy(spritename, ":36");
			edit_num = 0;
			thing_rad = 0;

			if(strcasecmp(currtext, "pickup") == 0 ||
			   strcasecmp(currtext, "breakable") == 0 ||
			   strcasecmp(currtext, "projectile") == 0 ||
			   strcasecmp(currtext, "actor") == 0)
			{
				currtext = next_string(NULL);
				if(end_of_decorate)
					break;
			}

			strncpy(thingname, currtext, sizeof(thingname));

			currtext = next_string(NULL);
			while(strcmp(currtext, "{") != 0 && !end_of_decorate)
			{
				if(strcmp(currtext, ":") == 0)
				{
					next_string(NULL);
					currtext = next_string(NULL);
				}

				edit_num = atoi(currtext);
			}
		}

		while(strcmp(currtext, "}") != 0 && !end_of_decorate)
		{
			if(strcasecmp(currtext, "Sprite") == 0)
			{
				strncpy(spritename, next_string(NULL), sizeof(spritename));
				if(!find_sprite(spritename))
					strcpy(spritename, ":36");
			}
			else if(strcasecmp(currtext, "DoomEdNum") == 0)
			{
				edit_num = atoi(next_string(NULL));
				if(edit_num < 0)
					edit_num = 0;
			}
			else if(strcasecmp(currtext, "Radius") == 0)
			{
				thing_rad = atoi(next_string(NULL));
				if(thing_rad < 0)
					thing_rad = 0;
			}

			currtext = next_string(NULL);
		}

		if(edit_num > 0 && strlen(thingname))
		{
/* 65,	RED,		20,	"Heavy Weapon Dude", "CPOSF1" */
			char buf[256];
			sprintf(buf, "%i,\tCYAN,\t%i,\t\"%s\",\t\"%s\"\n", edit_num, thing_rad, thingname, spritename);

			if(cur_dec_count == 35)
			{
				cur_dec_count = 0;
				++cur_dec_list;

				sprintf(thingname, "\"Decorate Things (%i)\"", cur_dec_list);
				add_thing_class(thingname);
			}

			fprintf(stderr, "Adding: %s", buf);
			add_thing(buf);
			++cur_dec_count;

			memset(thingname, 0, sizeof(thingname));
		}
		currtext = next_string(NULL);
	}

	free(text);
}
